models/Etiqueta.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "etiqueta".
 *
 * @property int $ide
 * @property string $nombre
 *
 * @property Ne[] $nes
 */
class Etiqueta extends \yii\db\ActiveRecord
{
    public $noticias;
    public $autores;
    public $titulo;
    public $texto;
    public $idn;
    
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'etiqueta';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['nombre'], 'string', 'max' => 127],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'ide' => 'Ide',
            'nombre' => 'Nombre',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getNes()
    {
        return $this->hasMany(Ne::className(), ['ide' => 'ide']);
    }
}

controllers/EtiquetaController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Etiqueta;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\data\SqlDataProvider;
use yii\db\Query;
use app\models\Ne;
use app\models\Noticia;

/**
 * EtiquetaController implements the CRUD actions for Etiqueta model.
 */
class EtiquetaController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }
    
        /**
     * Lists all Etiqueta models.
     * @return mixed
     */
    public function actionList()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Etiqueta::find(),
        ]);

        return $this->render('listview', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Lists all Etiqueta models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Etiqueta::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Etiqueta model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Etiqueta model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Etiqueta();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->ide]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Etiqueta model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->ide]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Etiqueta model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Etiqueta model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Etiqueta the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Etiqueta::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    /**
     * Lists all Etiqueta models.
     * @return mixed
     */
    public function actionListar()
    {
       // mediante DAO
      $numero=Yii::$app->
              db->
              createCommand("SELECT distinct COUNT(*) FROM etiqueta INNER JOIN ne USING(ide) INNER JOIN noticia USING(idn) GROUP BY
                nombre")
              ->queryScalar();
              
        $dataProvider = new SqlDataProvider([
            'sql'=>'SELECT ide, nombre, COUNT(*) noticias, COUNT(DISTINCT ida) autores 
                FROM etiqueta INNER JOIN ne USING(ide) INNER JOIN noticia USING(idn) GROUP BY
                nombre,ide',
            ]);
        
       /* $dataProvider = new ActiveDataProvider([
            'query' => Etiqueta::find(),
        ]);*/
 
       return $this->render('etiqueta', [
            'dataProvider' => $dataProvider,
            "campos"=>['nombre', 'noticias', 'autores', 'ide'], 
        ]);
       
    }
    public function actionNoticiasetiqueta($id){
        
        // mediante active record
        /*SELECT DISTINCT ciclista.dorsal dorsal FROM ciclista INNER JOIN etapa ON ciclista.dorsal = etapa.dorsal LEFT JOIN
        puerto ON etapa.numetapa = puerto.numetapa WHERE puerto.numetapa IS NULL;*/
        $c1 = Ne::find()
               ->distinct() 
               ->innerJoin('noticia', 'ne.idn = noticia.idn')
               ->where(['ide'=>$id]);
       
        $dataProvider = new ActiveDataProvider([
            'query' => $c1,
          ]);
    
        return $this->render("listview", [
            "dataProvider"=>$dataProvider,
           "campos"=>['titulo, texto'], 
           
        ]);
        
    }
        
        
     
    
    
    
        
        
      
    
      
      
      
      
    }

views/etiqueta/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Etiqueta */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="etiqueta-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'nombre')->textInput(['maxlength' => true]) ?>

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/etiqueta/_listar.php
<?php
use yii\helpers\Html;
use yii\helpers\ArrayHelper;

?>
<div class="col-sm-4 col-md-6">
    <div class="thumbnail">
       <div class="caption">
        
        <p>
          <h2><?= $model->n->titulo ?> </h2>
          
        </p>
        <p><?= $model->n->texto ?> </p>
                
    </div>
  </div>

views/etiqueta/create.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Etiqueta */

$this->title = 'Create Etiqueta';
$this->params['breadcrumbs'][] = ['label' => 'Etiquetas', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="etiqueta-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/etiqueta/etiqueta.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Etiquetas';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="etiqueta-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            'nombre',
            'noticias',
            'autores',
            [
            'label'=>'Ver noticias',
            'format'=>'raw',
            'content'=>function($model){
                return Html::a('Ver noticias', ['etiqueta/noticiasetiqueta', 'id'=>$model['ide']],
                        ['class'=>'']
            );
            }     
            ], 
                    
        ],
    ]); ?>


</div>

views/etiqueta/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Etiquetas';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="etiqueta-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Create Etiqueta', ['create'], ['class' => 'btn btn-success']) ?>
    </p>


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'ide',
            'nombre',

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>


</div>

views/etiqueta/listview.php
<div>
<h1>Listado de noticias</h1>
</div>

<div class="row">
<?php
use yii\widgets\ListView;
/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_listar', /*Recomendado _ el guion  que se muestra una vista dentro de otra */
]);
?>
</div>

views/etiqueta/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Etiqueta */

$this->title = 'Update Etiqueta: ' . $model->ide;
$this->params['breadcrumbs'][] = ['label' => 'Etiquetas', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->ide, 'url' => ['view', 'id' => $model->ide]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="etiqueta-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/etiqueta/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Etiqueta */

$this->title = $model->ide;
$this->params['breadcrumbs'][] = ['label' => 'Etiquetas', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="etiqueta-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->ide], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->ide], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'ide',
            'nombre',
        ],
    ]) ?>

</div>